'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _targetIsDescendant = require('./targetIsDescendant');

var _targetIsDescendant2 = _interopRequireDefault(_targetIsDescendant);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var makeSureValue = function makeSureValue(val, options, props) {
  return props[val] === undefined ? options[val] : props[val];
};

exports.default = function (options) {
  return function (ComposedComponent) {
    return function (_Component) {
      _inherits(PortalHoc, _Component);

      function PortalHoc() {
        var _ref;

        var _temp, _this, _ret;

        _classCallCheck(this, PortalHoc);

        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PortalHoc.__proto__ || Object.getPrototypeOf(PortalHoc)).call.apply(_ref, [this].concat(args))), _this), _this.ensureClosedPortal = function () {
          if (_this.node) {
            (function () {
              var nodeToRemove = _this.node;
              // https://github.com/facebook/react/issues/6232
              setTimeout(function () {
                return (0, _reactDom.unmountComponentAtNode)(nodeToRemove);
              }, 0);
              document.body.removeChild(_this.node);
              _this.portal = null;
              _this.node = null;
              _this.toggle = null;
              _this.handleListeners('remove');
            })();
          }
        }, _this.ensureOpenPortal = function () {
          if (!_this.node) {
            _this.node = document.createElement('div');
            document.body.appendChild(_this.node);
            _this.handleListeners('add');
          }

          // we could make some performance gains by doing a shallow equal on the props
          _this.portal = (0, _reactDom.unstable_renderSubtreeIntoContainer)(_this, _react2.default.createElement(ComposedComponent, _extends({}, _this.props, { closePortal: _this.ensureClosedPortal })), _this.node);
        }, _this.handleDocumentClick = function (e) {
          // close as long as they didn't click the modal or the toggle
          if (!(0, _targetIsDescendant2.default)(e.target, (0, _reactDom.findDOMNode)(_this.portal))) {
            if (!_this.toggle || !(0, _targetIsDescendant2.default)(e.target, (0, _reactDom.findDOMNode)(_this.toggle))) {
              _this.ensureClosedPortal();
            }
          }
        }, _this.handleKeydown = function (e) {
          if (e.key === 'Escape') {
            _this.ensureClosedPortal();
          }
        }, _this.togglePortal = function () {
          if (_this.node) {
            _this.ensureClosedPortal();
          } else {
            _this.ensureOpenPortal();
          }
        }, _temp), _possibleConstructorReturn(_this, _ret);
      }

      _createClass(PortalHoc, [{
        key: 'componentDidMount',
        value: function componentDidMount() {
          var isOpen = makeSureValue('isOpen', options, this.props);
          this.ensurePortalState(isOpen);
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(nextProps) {
          var isOpen = nextProps.isOpen;

          if (isOpen !== this.props.isOpen) {
            this.ensurePortalState(isOpen);
          }
        }
      }, {
        key: 'componentWillUnmount',
        value: function componentWillUnmount() {
          this.ensureClosedPortal();
        }
      }, {
        key: 'ensurePortalState',
        value: function ensurePortalState(isOpen) {
          if (isOpen) {
            this.ensureOpenPortal();
          } else {
            this.ensureClosedPortal();
          }
        }
      }, {
        key: 'handleListeners',
        value: function handleListeners(type) {
          var escToClose = makeSureValue('escToClose', options, this.props);
          var clickToClose = makeSureValue('clickToClose', options, this.props);
          var handle = type === 'add' ? document.addEventListener : document.removeEventListener;
          if (escToClose) {
            handle('keydown', this.handleKeydown);
          }
          if (clickToClose) {
            handle('click', this.handleDocumentClick);
            handle('touchstart', this.handleDocumentClick);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          var _this2 = this;

          var toggle = makeSureValue('toggle', options, this.props);
          if (toggle) {
            var onClick = function onClick(e) {
              if (toggle.props.onClick) {
                toggle.props.onClick(e);
              }
              // the above click handler might be setting the state for the portal, and setState is async
              setTimeout(function () {
                return _this2.togglePortal();
              }, 0);
            };
            var ref = function ref(c) {
              _this2.toggle = c;
            };
            return (0, _react.cloneElement)(toggle, { onClick: onClick, ref: ref });
          }
          return null;
        }
      }]);

      return PortalHoc;
    }(_react.Component);
  };
};